# coding: utf-8

"""
    College Basketball Data API

    This API is in limited Beta for Patreon subscribers. It may have bugs and is subject to changes. API keys can be acquired from the CollegeFootballData.com website.

    The version of the OpenAPI document: 1.14.0
    Contact: admin@collegefootballdata.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr
from cbbd.models.recruit_committed_to import RecruitCommittedTo
from cbbd.models.recruit_hometown import RecruitHometown

class Recruit(BaseModel):
    """
    Recruit
    """
    id: StrictInt = Field(...)
    source_id: Optional[StrictStr] = Field(default=..., alias="sourceId")
    position: Optional[StrictStr] = Field(...)
    school_id: Optional[StrictInt] = Field(default=..., alias="schoolId")
    school: Optional[StrictStr] = Field(...)
    hometown: Optional[RecruitHometown] = Field(...)
    committed_to: Optional[RecruitCommittedTo] = Field(default=..., alias="committedTo")
    athlete_id: Optional[StrictInt] = Field(default=..., alias="athleteId")
    year: StrictInt = Field(...)
    name: StrictStr = Field(...)
    height_inches: Optional[StrictInt] = Field(default=..., alias="heightInches")
    weight_pounds: Optional[StrictInt] = Field(default=..., alias="weightPounds")
    stars: StrictInt = Field(...)
    rating: Union[StrictFloat, StrictInt] = Field(...)
    ranking: Optional[StrictInt] = Field(...)
    __properties = ["id", "sourceId", "position", "schoolId", "school", "hometown", "committedTo", "athleteId", "year", "name", "heightInches", "weightPounds", "stars", "rating", "ranking"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Recruit:
        """Create an instance of Recruit from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of hometown
        if self.hometown:
            _dict['hometown'] = self.hometown.to_dict()
        # override the default output from pydantic by calling `to_dict()` of committed_to
        if self.committed_to:
            _dict['committedTo'] = self.committed_to.to_dict()
        # set to None if source_id (nullable) is None
        # and __fields_set__ contains the field
        if self.source_id is None and "source_id" in self.__fields_set__:
            _dict['sourceId'] = None

        # set to None if position (nullable) is None
        # and __fields_set__ contains the field
        if self.position is None and "position" in self.__fields_set__:
            _dict['position'] = None

        # set to None if school_id (nullable) is None
        # and __fields_set__ contains the field
        if self.school_id is None and "school_id" in self.__fields_set__:
            _dict['schoolId'] = None

        # set to None if school (nullable) is None
        # and __fields_set__ contains the field
        if self.school is None and "school" in self.__fields_set__:
            _dict['school'] = None

        # set to None if hometown (nullable) is None
        # and __fields_set__ contains the field
        if self.hometown is None and "hometown" in self.__fields_set__:
            _dict['hometown'] = None

        # set to None if committed_to (nullable) is None
        # and __fields_set__ contains the field
        if self.committed_to is None and "committed_to" in self.__fields_set__:
            _dict['committedTo'] = None

        # set to None if athlete_id (nullable) is None
        # and __fields_set__ contains the field
        if self.athlete_id is None and "athlete_id" in self.__fields_set__:
            _dict['athleteId'] = None

        # set to None if height_inches (nullable) is None
        # and __fields_set__ contains the field
        if self.height_inches is None and "height_inches" in self.__fields_set__:
            _dict['heightInches'] = None

        # set to None if weight_pounds (nullable) is None
        # and __fields_set__ contains the field
        if self.weight_pounds is None and "weight_pounds" in self.__fields_set__:
            _dict['weightPounds'] = None

        # set to None if ranking (nullable) is None
        # and __fields_set__ contains the field
        if self.ranking is None and "ranking" in self.__fields_set__:
            _dict['ranking'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Recruit:
        """Create an instance of Recruit from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Recruit.parse_obj(obj)

        _obj = Recruit.parse_obj({
            "id": obj.get("id"),
            "source_id": obj.get("sourceId"),
            "position": obj.get("position"),
            "school_id": obj.get("schoolId"),
            "school": obj.get("school"),
            "hometown": RecruitHometown.from_dict(obj.get("hometown")) if obj.get("hometown") is not None else None,
            "committed_to": RecruitCommittedTo.from_dict(obj.get("committedTo")) if obj.get("committedTo") is not None else None,
            "athlete_id": obj.get("athleteId"),
            "year": obj.get("year"),
            "name": obj.get("name"),
            "height_inches": obj.get("heightInches"),
            "weight_pounds": obj.get("weightPounds"),
            "stars": obj.get("stars"),
            "rating": obj.get("rating"),
            "ranking": obj.get("ranking")
        })
        return _obj


